/*
 * Charts.h, part of makrokosmos.
 */

/* Chart entry constants */
#define CHART_BLANK		0x00
/* Blank: Dark blue ? */
#define CHART_VISITED		0x01
/* white */
#define CHART_FLEETSCANNED	0x02
/* green */
#define	CHART_BODYSCANNED	0x04
/* Bright blue */
#define CHART_FULLSCANNED	0x06
/* cyan */
#define	CHART_COLONIES		0x08
/* Letter c */
#define CHART_MYFORCES		0x10
/* @ */
#define CHART_FLEETS		0x20
/* Letter f */
#define	CHART_BODIES		0x40
/* Letter o.  Not shown if there's colonies. */
#define	CHART_DETAILS		0x80
/* Symbol # */


void load_chart_entry(struct coord_t *c, int *entry);
void open_chart_file();
void close_chart_file();
void set_chart_entry(struct coord_t *c, char entry);
void write_chart_slice(char *slice, struct coord_t *c,
  struct coord_t *slicesize);
void load_chart_slice(struct coord_t *c1, struct coord_t *c2, char *buf,
  int buflen);
void add_log_to_chart(struct gstrlist_t *list, time_t *lastupdated);
void append_chart_dotor(struct coord_t *start, char val);

struct compressed_coord_t {
  guint8 x;
  guint8 y;
  guint8 z;
};

/* Chart entries */
#define	CHARTENT_DOTVAL	0x01
#define CHARTENT_LINEOR	0x02
#define CHARTENT_DOTOR	0x03

/* Emphases to use in chart display */
#define EMPH_MIN	0x00
#define EMPH_DEFAULT	0x00
#define EMPH_UNSCANNED	0x01
#define EMPH_MAX	0x01
