/* Makrokosmos (C)2000 Deekoo L. */

#ifdef _INCLUDE_POPULII_H
#error Multiple includes of populii.h.
#endif

void dispose_populii(struct populii_t *p);
void populate_item(struct item_t *i, struct populii_t *p);
void dispose_item_popstrs(struct item_t *i);
void add_popstr_to_item(struct item_t *i, char *popstr);
void extract_item_populii(struct item_t *i, struct populii_t *p);
void breed_to_now(struct populii_t *p, int maxpop, struct ship_t *s);
void absorb_populii(struct populii_t *dest, struct populii_t *src);
int breedable(struct pop_t *p);
void move_population_to_fleet(struct fleet_t *f, struct pop_t *p);
void move_populii_to_fleet(struct fleet_t *f, struct populii_t *p);
void absorb_populii_limited(struct populii_t *dest, struct populii_t *src,
  int max);
int habitability(char *zone, struct species_t *species);
#ifdef _INCLUDE_UTIL_H
void extract_seed_populii(struct populii_t *src, struct populii_t *seed,
  struct gstrlist_t *specie);
int habitability_to_populii(char *zone, struct populii_t *p,
  struct gstrlist_t *specie);
void extract_half_populii(struct populii_t *src, struct populii_t *dest,
  struct gstrlist_t *specie);
//void absorb_item_pop_specie(struct populii_t *dest, struct item_t *src,
//  const struct gstrlist_t *specie, int max);
void absorb_item_populii_specie(struct populii_t *dest,
  struct item_t *src, const struct gstrlist_t *specie, int max);

#endif
void dispose_species(struct species_t *s);
GString *genderstring(GString *genders, int num);
void load_species(char *str, struct species_t *s);
void create_newplayer_population(struct populii_t *p, struct species_t *s);
void trim_populii(struct populii_t *p, struct populii_t *overflow,
  int num);
void extract_species_params(struct species_t *s, struct species_params_t *p);
int shanghai_itempop_senescent(struct item_t *i, int totalamt);
int shanghai_itempop_maximal(struct item_t *i, int totalamt);
void breed_to_time(struct populii_t *p, int maxpop, struct ship_t *s,
  int time);
struct listpane_data_t *habitatpane_data(GString *habitat);
GString *habitatpane_gstring(struct listpane_data_t *data);

#ifdef _INCLUDE_UTIL_H
struct pop_totals_t {
  struct gstrlist_t list;
  int      *total;
};
#define null_pop_totals (struct pop_totals_t) { \
	list: null_gstrlist, total: NULL }
void extract_fleetpop_totals(struct pop_totals_t *totals, struct fleet_t *fleet);
void dispose_pop_totals(struct pop_totals_t *totals);
#endif

#define _INCLUDE_POPULII_H
