#!/usr/bin/perl -w

$am_root=($<==0);
$in_makrokosmos_group=0;
@groupent=getgrnam('makrokosmos');
if ($am_root) {
  $in_makrokosmos_group=1;
  if (!@groupent) {
    system("groupadd makrokosmos");
    @groupent=getgrnam('makrokosmos');
    if (!@groupent) {
      print "Unable to create Makrokosmos group.\n";
      $in_makrokosmos_group=0;
    }
  }
}
if (@groupent && ($( =~/(^| )$groupent[2]( |$)/)) {
  $in_makrokosmos_group=1;
}
if ($in_makrokosmos_group) {
  print "Group Makrokosmos exists.  Datafiles are being marked owned by group makrokosmos.\n";
  print "Setting Makrokosmos binary sgid makrokosmos.\n";
  $)=$groupent[2];
} else {
  print "Not in group Makrokosmos.  Installing for single-player use.\n";
}
if (-w '/var/lib/') {
  print "Installing game data in /var/lib/makrokosmos.\n";
  $datapath='/var/lib/makrokosmos';
} else {
  @pwent=getpwuid($<);
  $datapath="$pwent[7]/makrokosmos";
  print "Can't write to /var/lib.  Installing game data in $datapath.\n";
}
if (-w '/usr/local/bin') {
  print "Installing binary in /usr/local/bin.\n";
  $binpath='/usr/local/bin';
} else {
  print "Installing binary in $pwent[7]/bin.";
  $binpath="$pwent[7]/bin";
  if (!(-d $binpath)) {
    mkdir ($binpath,0700);
    print "(Created with mode 0700)";
  }
  print "\n";
}
mkdir($datapath,0750);
umask(077);
system("cp -r data/* $datapath");
if ($in_makrokosmos_group) {
  system("install -m 2755 obj/makrokosmos $binpath/makrokosmos");
} else {
  system("install -m 755 obj/makrokosmos $binpath/makrokosmos");
}
open(FILE,">>$datapath/chat/chat.log");
close(FILE);
@writable_dirs=(
	"$datapath/fleets/",
	"$datapath/fleets/Debris/",
	"$datapath/fleets/Detritus/",
	"$datapath/fleets/Junk/",
	"$datapath/fleets/Wreckage/",
	"$datapath/mail/",
	"$datapath/players/",
	"$datapath/sectors/",
	"$datapath/species/",
	"$datapath/charts/",
	"$datapath/chat/");
if ($in_makrokosmos_group) {
  chmod(02770,@writable_dirs);
  chmod(0660,"$datapath/makrokosmos.cfg");
} else {
  chmod(0700,@writable_dirs);
  chmod(0600,"$datapath/makrokosmos.cfg");
}
#	chmod 2770 \
#	  /var/lib/makrokosmos/fleets/{Debris,Detritus,Junk,Wreckage} \
#	  /var/lib/makrokosmos/{fleets,mail,players,sectors,species,charts,chat}
@readonly_dirs=(
	$datapath,
	"$datapath/items/",
	"$datapath/recipes/",
	"$datapath/ships/",
	"$datapath/fleets/Defaults/",
	"$datapath/items/Defaults/",
	"$datapath/species/Defaults/",
	);
if ($in_makrokosmos_group) {
  chmod(0750,@readonly_dirs);
} else {
  chmod(0700,@readonly_dirs);
}
#	chmod 750 /var/lib/makrokosmos/ \
#	  /var/lib/makrokosmos/{items,recipes,ships} \
#	  /var/lib/makrokosmos/{fleets,items,species}/Defaults
chmod(0755,"$datapath/help");
system("chmod 644 $datapath/help/*");
#	chmod 2111 /usr/local/games/makrokosmos
#	touch /var/lib/makrokosmos/private.log
open(FILE,">>$datapath/public.log");
close(FILE);
@logfiles=(
	"$datapath/public.log",
	"$datapath/private.log",
	"$datapath/chat/chat.log"
	);
if ($in_makrokosmos_group) {
  chmod(0660,@logfiles);
} else {
  chmod(0600,@logfiles);
}

#Makrokosmos is installed.
#The game binary lives in /usr/local/games/makrokosmos and should be sgid
#(not suid) makrokosmos.
#The game datafiles live in /var/lib/makrokosmos/.
#
#For help, tech support, new versions, and translucent yaks, see
#http://deekoo.net/technocracy/makrokosmos/
